package com.allmycode.services;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class MySaxHandler extends DefaultHandler {

  private static final String CURRENT_CONDITIONS =
//      "current_conditions";
        "current_condition";
  private static final String DATA = "data";
  private static final String CONDITION = "weatherDesc"; //"condition";
  private static final String TEMP_F = "temp_F"; //"temp_f";

  private Weather weather = new Weather();

  private boolean current_conditions = false;
  
  // Added:
  private boolean temp_f = false;
  private boolean weatherDescription = false;
  // End of some Added code.

  public Weather getWeather() {
    return weather;
  }

  @Override
  public void startElement(String namespaceURI,
      String localName, String qName,
      Attributes attributes) throws SAXException {

    if (localName.equals(CURRENT_CONDITIONS)) {
      current_conditions = true;
    } else {
      if (current_conditions) {
        if (localName.equals(TEMP_F)) {
          temp_f = true;
          /*String dataAttribute =
              attributes.getValue(DATA);
          weather.setTemperature(Integer
              .parseInt(dataAttribute));*/
        } else if (localName.equals(CONDITION)) {
          weatherDescription = true;
          /*String condAttribute =
              attributes.getValue(DATA);
          weather.setCondition(condAttribute);*/
        }
      }
    }
  }
  
  //Added:
  @Override
  public void characters(char chars[], int start, int length) throws SAXException {
    if (temp_f) {
      weather.setTemperature(Integer.parseInt(String.valueOf(chars, start, length)));
    } else if (weatherDescription) {
      weather.setCondition(String.valueOf(chars, start, length));
    }
  }
  //End of some Added code.

  @Override
  public void endElement(String namespaceURI,
      String localName, String qName) throws SAXException {
    if (localName.equals(CURRENT_CONDITIONS)) {
      current_conditions = false;
    } 
    //Added:
      else {
      if (localName.equals(TEMP_F)) {
        temp_f = false;
      } else if (localName.equals(CONDITION)) {
        weatherDescription = false;
      }
    //End of some Added code.
    }
  }
}
